%bcond_without repolib

%define reltag .redhat_1
%define namedreltag -redhat-1
%global namedversion %{version}%{?namedreltag}

Name:           guava-libraries
Version:        11.0.2
Release:        0.2%{?reltag}%{?dist}.1
Epoch:          0
Summary:        Google Core Libraries for Java
Group:          Development/Java
License:        ASL 2.0 
URL:            http://code.google.com/p/guava-libraries
%if 0
rm -rf guava-libraries && git clone -q -n https://code.google.com/p/guava-libraries && cd guava-libraries && git config core.autocrlf true && \
git archive --prefix=guava-libraries-11.0.2/ --format=tar v11.0.2 | bzip2 -9 > ../guava-libraries-11.0.2.tar.bz2
%endif
Source0:        guava-libraries-11.0.2.tar.bz2
Patch0:         guava-libraries-pom.patch
Patch1:         openjdk-inference.patch
BuildRequires:  jpackage-utils 
BuildRequires:  maven2
BuildRequires:  maven2-plugin-clean
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  junit >= 0:4.0
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Guava is a suite of core and expanded libraries that include 
utility classes, Google's collections, io classes, and much 
much more.

This project is a complete packaging of all the Guava libraries
into a single jar.  Individual portions of Guava can be used
by downloading the appropriate module and its dependencies.

%package -n guava
Group:          Development/Libraries/Java
Summary:        Guava: Google Core Libraries for Java
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
%if 0
XXX: don't require pom package at runtime
Requires:       guava-parent = %{epoch}:%{version}-%{release}
%endif
%if 0
FIXME: what package provides this in jboss?
XXX: this has optional=true in pom
Requires:       jsr-305
%endif
BuildRequires:  jdiff
BuildRequires:  jsr-305
BuildRequires:  junit >= 0:4.5
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-source
BuildRequires:  animal-sniffer
BuildRequires:  mojo-signatures

%description -n guava
Guava is a suite of core and expanded libraries that include
utility classes, google's collections, io classes, and much
much more.

This project is a complete packaging of all the Guava libraries
into a single jar.  Individual portions of Guava can be used
by downloading the appropriate module and its dependencies.

Guava (complete) has only one code dependency - javax.annotation,
per the JSR-305 spec.

%package -n guava-bootstrap
Group:          Development/Libraries/Java
Summary:        Guava Compilation Bootstrap Classes
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  maven2-plugin-compiler

%description -n guava-bootstrap
ExecutorService's type parameters changed between JDK5 and JDK6 in a
way that makes it impossible for our invokeAll/invokeAny methods to
match both at compile time. This project builds a JDK6-like copy of
ExecutorService (but with JDK5 compiler settings to ensure that it will
work with JRE5 at runtime).  This project's is then used in the bootstrap
class path of Guava proper.

%package -n guava-gwt
Group:          Development/Libraries/Java
Summary:        Guava GWT compatible libs
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
%if 0
XXX: don't require pom package at runtime
Requires:       guava-parent = %{epoch}:%{version}-%{release}
%endif
Requires:       guava = %{epoch}:%{version}-%{release}
BuildRequires:  gwt
BuildRequires:  gwt-devel
BuildRequires:  junit >= 0:4.5
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency

%description -n guava-gwt
Guava is a suite of core and expanded libraries that include
utility classes, google's collections, io classes, and much
much more.

This project includes GWT-friendly sources.

%package -n guava-parent
Group:          Development/Libraries/Java
Summary:        Guava Maven Parent
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
Requires:       oss-parent
BuildRequires:  oss-parent

%description -n guava-parent
Guava Maven Parent.

%package -n guava-testlib
Group:          Development/Libraries/Java
Summary:        Guava Testing Library
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
%if 0
XXX: don't require pom package at runtime
Requires:       guava-parent = %{epoch}:%{version}-%{release}
%endif
Requires:       guava = %{epoch}:%{version}-%{release}
Requires:       junit >= 0:4.5
Requires:       gwt-devel
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-source

%description -n guava-testlib
Guava testlib is a set of java classes used for more convenient
unit testing - particularly to assist the tests for Guava itself.

%package -n guava-tests
Group:          Development/Libraries/Java
Summary:        Guava Unit Tests
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
%if 0
XXX: don't require pom package at runtime
Requires:       guava-parent = %{epoch}:%{version}-%{release}
%endif
BuildRequires:  junit-truth
BuildRequires:  junit >= 0:4.5
BuildRequires:  easymock2
BuildRequires:  maven2-plugin-compiler

%description -n guava-tests
The unit tests for the Guava libraries - separated into a
separate artifact to allow for the testlibs to depend on guava
itself.

%package javadoc
Group:          Documentation
Summary:        Javadoc for %{name}
Requires:       jpackage-utils

%description javadoc
Javadoc for %{name}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1

%{__rm} guava/lib/jdiff.jar
%{__ln_s} `%{_bindir}/build-classpath jdiff` guava/lib/jdiff.jar
%{__rm} guava-tests/lib/libtruth.jar
%{__ln_s} `%{_bindir}/build-classpath truth` guava-tests/lib/libtruth.jar
%{__rm} guava-tests/lib/libtruth-gwt.jar

# FIXME: openjdk generics compilation errors
%{__rm} -r guava-tests/test/*

%build
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=jboss-releases::default::file://`pwd`/maven2-brew
# XXX: upstream runs: clean package source:jar site:jar javadoc:jar deploy
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} clean install javadoc:jar deploy javadoc:aggregate

# FIXME: deploy bug
%{__mv} maven2-brew/com/google/guava/guava/10.0.1-redhat-1/* maven2-brew/com/google/guava/guava/%{namedversion}/ || :
%{__rm} -rf maven2-brew/com/google/guava/guava/10.0.1-redhat-1/
#

%install
%{__rm} -rf %{buildroot}

# jars                                                                                                                                                                                                                                       
%{__mkdir_p} %{buildroot}%{_javadir}                                                                                                                                                                                                         
%{__cp} -p maven2-brew/com/google/guava/guava-bootstrap/%{namedversion}/guava-bootstrap-%{namedversion}-sources.jar %{buildroot}%{_javadir}/guava-bootstrap-%{namedversion}-sources.jar                                                      
##%{__cp} -p maven2-brew/com/google/guava/guava-bootstrap/%{namedversion}/guava-bootstrap-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/guava-bootstrap-%{namedversion}-javadoc.jar                                                      
%{__cp} -p maven2-brew/com/google/guava/guava-bootstrap/%{namedversion}/guava-bootstrap-%{namedversion}.jar %{buildroot}%{_javadir}/guava-bootstrap-%{namedversion}.jar                                                                      
%{__cp} -p maven2-brew/com/google/guava/guava-gwt/%{namedversion}/guava-gwt-%{namedversion}.jar %{buildroot}%{_javadir}/guava-gwt-%{namedversion}.jar
##%{__cp} -p maven2-brew/com/google/guava/guava-gwt/%{namedversion}/guava-gwt-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/guava-gwt-%{namedversion}-javadoc.jar
%{__cp} -p maven2-brew/com/google/guava/guava-gwt/%{namedversion}/guava-gwt-%{namedversion}-sources.jar %{buildroot}%{_javadir}/guava-gwt-%{namedversion}-sources.jar
##%{__cp} -p maven2-brew/com/google/guava/guava/%{namedversion}/guava-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/guava-%{namedversion}-javadoc.jar
%{__cp} -p maven2-brew/com/google/guava/guava/%{namedversion}/guava-%{namedversion}-sources.jar %{buildroot}%{_javadir}/guava-%{namedversion}-sources.jar
%{__cp} -p maven2-brew/com/google/guava/guava/%{namedversion}/guava-%{namedversion}.jar %{buildroot}%{_javadir}/guava-%{namedversion}.jar
%{__cp} -p maven2-brew/com/google/guava/guava-testlib/%{namedversion}/guava-testlib-%{namedversion}-sources.jar %{buildroot}%{_javadir}/guava-testlib-%{namedversion}-sources.jar
%{__cp} -p maven2-brew/com/google/guava/guava-testlib/%{namedversion}/guava-testlib-%{namedversion}.jar %{buildroot}%{_javadir}/guava-testlib-%{namedversion}.jar
##%{__cp} -p maven2-brew/com/google/guava/guava-testlib/%{namedversion}/guava-testlib-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/guava-testlib-%{namedversion}-javadoc.jar
#%{__cp} -p maven2-brew/com/google/guava/guava-tests/%{namedversion}/guava-tests-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/guava-tests-%{namedversion}-javadoc.jar
%{__cp} -p maven2-brew/com/google/guava/guava-tests/%{namedversion}/guava-tests-%{namedversion}.jar %{buildroot}%{_javadir}/guava-tests-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%{__cp} -p maven2-brew/com/google/guava/guava-bootstrap/%{namedversion}/guava-bootstrap-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-guava-bootstrap.pom
%{__cp} -p maven2-brew/com/google/guava/guava-gwt/%{namedversion}/guava-gwt-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-guava-gwt.pom
%{__cp} -p maven2-brew/com/google/guava/guava/%{namedversion}/guava-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-guava.pom
%{__cp} -p maven2-brew/com/google/guava/guava-parent/%{namedversion}/guava-parent-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-guava-parent.pom
%{__cp} -p maven2-brew/com/google/guava/guava-testlib/%{namedversion}/guava-testlib-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-guava-testlib.pom
%{__cp} -p maven2-brew/com/google/guava/guava-tests/%{namedversion}/guava-tests-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-guava-tests.pom

# depmaps
%add_to_maven_depmap com.google.guava guava-bootstrap %{namedversion} JPP guava-bootstrap
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/guava-bootstrap
%add_to_maven_depmap com.google.guava guava-gwt %{namedversion} JPP guava-gwt
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/guava-gwt
%add_to_maven_depmap com.google.guava guava-parent %{namedversion} JPP guava-parent
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/guava-parent
%add_to_maven_depmap com.google.guava guava-testlib %{namedversion} JPP guava-testlib
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/guava-testlib
%add_to_maven_depmap com.google.guava guava-tests %{namedversion} JPP guava-tests
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/guava-tests
%add_to_maven_depmap com.google.guava guava %{namedversion} JPP guava
[ -f %{buildroot}%{_mavendepmapfragdir}/guava ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/guava

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{nameversion}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{nameversion}
%{__ln_s} %{name}-%{nameversion} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%post -n guava
%update_maven_depmap

%postun -n guava
%update_maven_depmap

%post -n guava-bootstrap
%update_maven_depmap

%postun -n guava-bootstrap
%update_maven_depmap

%post -n guava-gwt
%update_maven_depmap

%postun -n guava-gwt
%update_maven_depmap

%post -n guava-parent
%update_maven_depmap

%postun -n guava-parent
%update_maven_depmap

%post -n guava-testlib
%update_maven_depmap

%postun -n guava-testlib
%update_maven_depmap

%post -n guava-tests
%update_maven_depmap

%postun -n guava-tests
%update_maven_depmap

%clean
%{__rm} -rf %{buildroot}

%files -n guava
%defattr(0644,root,root,0755)
%doc AUTHORS CONTRIBUTORS COPYING README README.maven
##%{_javadir}*/guava-%{namedversion}-javadoc.jar
##%{_javadir}*/guava-javadoc.jar
%{_javadir}*/guava-%{namedversion}-sources.jar
%{_javadir}*/guava-sources.jar
%{_javadir}*/guava-%{namedversion}.jar
%{_javadir}*/guava.jar
%{_mavenpomdir}/JPP-guava.pom
%{_mavendepmapfragdir}/guava

%files -n guava-bootstrap
%defattr(0644,root,root,0755)
%{_javadir}*/guava-bootstrap-%{namedversion}-sources.jar
%{_javadir}*/guava-bootstrap-sources.jar
##%{_javadir}*/guava-bootstrap-%{namedversion}-javadoc.jar
##%{_javadir}*/guava-bootstrap-javadoc.jar
%{_javadir}*/guava-bootstrap-%{namedversion}.jar
%{_javadir}*/guava-bootstrap.jar
%{_mavenpomdir}/JPP-guava-bootstrap.pom
%{_mavendepmapfragdir}/guava-bootstrap

%files -n guava-gwt
%defattr(0644,root,root,0755)
%{_javadir}*/guava-gwt-%{namedversion}.jar
%{_javadir}*/guava-gwt.jar
##%{_javadir}*/guava-gwt-%{namedversion}-javadoc.jar
##%{_javadir}*/guava-gwt-javadoc.jar
%{_javadir}*/guava-gwt-%{namedversion}-sources.jar
%{_javadir}*/guava-gwt-sources.jar
%{_mavenpomdir}/JPP-guava-gwt.pom
%{_mavendepmapfragdir}/guava-gwt

%files -n guava-parent
%defattr(0644,root,root,0755)
%{_mavenpomdir}/JPP-guava-parent.pom
%{_mavendepmapfragdir}/guava-parent

%files -n guava-testlib
%defattr(0644,root,root,0755)
%{_javadir}*/guava-testlib-%{namedversion}-sources.jar
%{_javadir}*/guava-testlib-sources.jar
%{_javadir}*/guava-testlib-%{namedversion}.jar
%{_javadir}*/guava-testlib.jar
##%{_javadir}*/guava-testlib-%{namedversion}-javadoc.jar
##%{_javadir}*/guava-testlib-javadoc.jar
%{_mavenpomdir}/JPP-guava-testlib.pom
%{_mavendepmapfragdir}/guava-testlib

%files -n guava-tests
%defattr(0644,root,root,0755)
#%{_javadir}*/guava-tests-%{namedversion}-javadoc.jar
#%{_javadir}*/guava-tests-javadoc.jar
%{_javadir}*/guava-tests-%{namedversion}.jar
%{_mavenpomdir}/JPP-guava-tests.pom
%{_javadir}*/guava-tests.jar
%{_mavendepmapfragdir}/guava-tests

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{nameversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri May 25 2012 Martha Benitez <mbenitez@redhat.com> - 0:11.0.2-0.2.redhat_1
- Remove javadoc.jar files from main packages

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:11.0.2-0.1_redhat_1.1
- Rebuild using cache signing

* Mon Mar 26 2012 David Walluck <dwalluck@redhat.com> 0:11.0.2-0.1
- 11.0.2

* Thu Feb 02 2012 David Walluck <dwalluck@redhat.com> 0:10.0.1-0.6
- remove Requires: guava-parent (no pom at runtime)
- remove Requires: jsr-305 (optional)

* Thu Nov 17 2011 David Walluck <dwalluck@redhat.com> 0:10.0.1-0.4_redhat_1
- fix oss-parent version
- fix Release tag

* Tue Nov 15 2011 David Walluck <dwalluck@redhat.com> 0:10.0.1-0.3_redhat_1
- use external libtruth

* Sun Nov 13 2011 David Walluck <dwalluck@redhat.com> 0:10.0.1-0.2_redhat_1
- BuildRequires: jdiff
- fix package names

* Sun Nov 13 2011 David Walluck <dwalluck@redhat.com> 0:10.0.1-0.1_redhat_1
- release
